﻿	' Uses only integers in per-sample logic!
Public Class SawtoothOscillator
    Implements IMonoSampleProvider

    Private sampleRate As Integer

    Private angle As UInteger

    Private angleIncrement As UInteger

		Public Sub New(ByVal sampleRate As Integer)
			Me.sampleRate = sampleRate
		End Sub

		Public Property Frequency As Double
			Set(ByVal value As Double)
            angleIncrement = CUInt(Fix(UInt32.MaxValue * value / sampleRate))
        End Set

			Get
            Return CDbl(angleIncrement) * sampleRate / UInt32.MaxValue
			End Get
		End Property

		Public Function GetNextSample() As Short Implements IMonoSampleProvider.GetNextSample
        angle += angleIncrement
        Return CShort((angle >> 16) + Short.MinValue)
		End Function
	End Class
