﻿Public Class StereoToMonoMixerInput
    Implements IMixerInput

    Public Sub New()
    End Sub

    Public Sub New(ByVal input As IMonoSampleProvider)
        Me.New()
        Me.Input = input
    End Sub

    Public Property Input As IMonoSampleProvider

    Public Function GetNextSample() As AudioSample Implements Petzold.MusicSynthesis.IStereoSampleProvider.GetNextSample
        Dim sample As Short = 0

        If Me.Input IsNot Nothing Then
            sample = Input.GetNextSample
        End If

        Return New AudioSample With {.Left = sample, .Right = sample}
    End Function
End Class
